Description

Some email clients will always send attachments with a mime-type of application/octet-stream instead of correctly setting the

attachment of the mime-type. We are aware of Outlook 15 showing this behaviour, but it might not be the only one.

This is a problem in the case where the front-end web server behind which Redmine runs sends the X-Content-Type-Options: nosniff

header, which stops the browser from trying to guess the mime type of files the server sends it (this header is set on the Planio

platform for security reasons).

This combination leads to thumbnails not being shown:

Redmine blindly trusts the mime-type set by the email client source:/branches/2.6-stable/app/models/mail_handler.rb#L276

This mime-type gets stored to the DB

And is served back as the Content-Type of the corresponding thumbnail 

source:/branches/2.6-stable/app/controllers/attachments_controller.rb#L63

The browser tries to fetch the thumbnail but gets a file with the Content-Type set to application/octet-stream, which isn't

considered an image and a broken link/broken image is shown.

Associated revisions

Revision 14034 - 2015-02-19 18:46 - Jean-Philippe Lang

Send a better content type than application/octet-stream (#19131).

Revision 14036 - 2015-02-19 20:01 - Jean-Philippe Lang

Merged r14034 (#19131).

History

#1 - 2015-02-18 21:01 - Felix Schäfer

- File 19131.patch added

The attached patch tries to better guess the mime type of attachments incoming via email if the mime-type of the attachment is set to

application/octet-stream.

If this is an acceptable solution, I would also add a migration to try to find a better mime type than application/octet-stream for existing attachments

with that content type.

#2 - 2015-02-18 21:12 - Jean-Philippe Lang

Any reason to do this in the mail handler and not in the Attachment model? If an image is uploaded via a browser or the API with an incorrect content

type, thumbnails and inline images might be broken as well.

#3 - 2015-02-18 21:16 - Felix Schäfer

We have only observed this for emails, but this can be moved to the model without problem too. I will adapt the patch in consequence.

#4 - 2015-02-18 21:21 - Jean-Philippe Lang

Or maybe just store the provided content type and guess a better one when a serving a file, just like it's already done when an attachment have a

blank content type. No need for a migration each time we change the guess rule.

#5 - 2015-02-18 21:23 - Jean-Philippe Lang

Index: app/controllers/attachments_controller.rb
https://www.redmine.org/projects/redmine/repository/svn/entry/branches/2.6-stable/app/models/mail_handler.rb#L276
https://www.redmine.org/projects/redmine/repository/svn/entry/branches/2.6-stable/app/controllers/attachments_controller.rb#L63


===================================================================

--- app/controllers/attachments_controller.rb    (revision 13994)

+++ app/controllers/attachments_controller.rb    (working copy)

@@ -183,7 +183,7 @@

   def detect_content_type(attachment)

     content_type = attachment.content_type

-    if content_type.blank?

+    if content_type.blank? || content_type == "application/octet-stream" 

       content_type = Redmine::MimeType.of(attachment.filename)

     end

     content_type.to_s

#6 - 2015-02-18 21:27 - Felix Schäfer

This is in fact exactly what we have done for Planio until we had worked out a solution here. I had thought the create-time guessing better as this

would have to be done only once for each attachment, but that works well too and avoids additional migrations.

#7 - 2015-02-19 05:10 - Toshi MARUYAMA

OpenProject (GPL3) uses another approach of attachment detection.

https://github.com/opf/openproject/commit/fb096b0c86eec9bf49612ef6c8768000c3099841

#8 - 2015-02-19 11:54 - Jean-Philippe Lang

Toshi MARUYAMA wrote:

OpenProject (GPL3) uses another approach of attachment detection.

 Sounds a bit overkill to me.

#9 - 2015-02-19 18:47 - Jean-Philippe Lang

- Tracker changed from Defect to Feature

- Subject changed from Don't trust MUAs to always set the correct mime-type for attachments to Use a better content type for attachments created

with application/octet-stream

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Target version set to 3.0.0

- Resolution set to Fixed

Change committed in r14034.

#10 - 2015-02-19 20:07 - Jean-Philippe Lang

- Status changed from Resolved to Closed

#11 - 2015-02-19 20:29 - Felix Schäfer

Thanks!

Files

19131.patch 18.6 KB 2015-02-18 Felix Schäfer
